#ifndef _BASIC_MRN_HANDLER_H
#define _BASIC_MRN_HANDLER_H

#include "rtr/rsslReactor.h"

#ifdef __cplusplus
extern "C" {
#endif

#define GUID_FID	4271
#define MRN_SRC		12215
#define MRN_TYPE	8593
#define FRAG_NUM	32479
#define FRAGMENT	32641
#define TOT_SIZE	32480

#define GUID_SIZE		256
#define MRN_SRC_SIZE	41
#define MRN_TYPE_SIZE	17

	/* Machine Readable News Item */
	typedef struct machineReadableNewsItem{
		RsslBuffer fragmentBuffer;
		char guid[GUID_SIZE];
		char source[MRN_SRC_SIZE];
		char type[MRN_TYPE_SIZE];
		RsslUInt64 fragmentNumber;
		RsslUInt64 expectedSize;
	}MachineReadableNewsItem;

	/*
	* Decodes the Machine Readable News Payload.
	* The method decodes the field entry data in field list and add data to MachineReadableNewsItem.
	* And depend on fragment number and expectSize, it either decompress, copy, or add the fragment to multiFragItem global variable.
	* Returns success if decoding succeeds or failure if decoding fails.
	* dIter - The decode iterator
	*/
	RsslRet decodeMRNPayload(RsslDataDictionary *dictionary, RsslDecodeIterator *dIter);

#ifdef __cplusplus
};
#endif

#endif